


<h1><a name="c" id="c">C</a></h1>
<div class="level1">

<p>

<a href="http://en.wikipedia.org/wiki/C_(programming_language)" class="interwiki iw_wp" title="http://en.wikipedia.org/wiki/C_(programming_language)">C</a>
</p>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "C" [1-52] -->
<h2><a name="how_to_print_the_current_time" id="how_to_print_the_current_time">How to print the current time</a></h2>
<div class="level2">

<p>

Using <a href="http://www.cplusplus.com/reference/clibrary/ctime/strftime/" class="urlextern" title="http://www.cplusplus.com/reference/clibrary/ctime/strftime/"  rel="nofollow">strftime</a>.
</p>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=c&amp;codeblock=0" title="Download Snippet" class="mediafile mf_c">show_time.c</a></dt>
<dd><pre class="code file c"><span class="co2">#include &lt;stdio.h&gt;</span>
<span class="co2">#include &lt;time.h&gt;</span>
&nbsp;
<span class="kw4">int</span> main<span class="br0">&#40;</span><span class="br0">&#41;</span>
<span class="br0">&#123;</span>
	time_t  currtime<span class="sy0">;</span>
	<span class="kw4">char</span> charTime<span class="br0">&#91;</span>100<span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#123;</span>0<span class="br0">&#125;</span><span class="sy0">;</span>
	time<span class="br0">&#40;</span><span class="sy0">&amp;</span>currtime<span class="br0">&#41;</span><span class="sy0">;</span>
	strftime<span class="br0">&#40;</span>charTime<span class="sy0">,</span><span class="kw4">sizeof</span><span class="br0">&#40;</span>charTime<span class="br0">&#41;</span><span class="sy0">-</span><span class="nu0">1</span><span class="sy0">,</span><span class="st0">&quot;%c&quot;</span><span class="sy0">,</span>localtime<span class="br0">&#40;</span><span class="sy0">&amp;</span>currtime<span class="br0">&#41;</span><span class="br0">&#41;</span><span class="sy0">;</span>
	<a href="http://www.opengroup.org/onlinepubs/009695399/functions/printf.html"><span class="kw3">printf</span></a><span class="br0">&#40;</span><span class="st0">&quot;time: %s<span class="es1">\n</span>&quot;</span><span class="sy0">,</span> charTime<span class="br0">&#41;</span><span class="sy0">;</span>
	<span class="coMULTI">/* &quot;time: Sat Apr 17 11:43:47 2010&quot; */</span>
<span class="br0">&#125;</span></pre>
</dd></dl>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to print the current time" [53-462] -->
<h2><a name="how_to_install_colorgcc" id="how_to_install_colorgcc">How to install colorgcc</a></h2>
<div class="level2">
<pre class="code bash">$ <span class="kw2">sudo</span> <span class="kw2">apt-get</span> <span class="kw2">install</span> colorgcc
$ <span class="kw3">cd</span> <span class="sy0">/</span>usr<span class="sy0">/</span>local<span class="sy0">/</span>bin
$ <span class="kw2">sudo</span> <span class="kw2">ln</span> <span class="re5">-s</span> <span class="sy0">/</span>usr<span class="sy0">/</span>bin<span class="sy0">/</span>colorgcc <span class="kw2">gcc</span>
$ <span class="kw2">sudo</span> <span class="kw2">ln</span> <span class="re5">-s</span> <span class="sy0">/</span>usr<span class="sy0">/</span>bin<span class="sy0">/</span>colorgcc <span class="kw2">g++</span></pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to install colorgcc" [463-642] -->
<h2><a name="tail_recursion_without_return" id="tail_recursion_without_return">Tail Recursion Without Return</a></h2>
<div class="level2">

<p>

In a function with a <a href="http://en.wikipedia.org/wiki/Tail_recursion" class="interwiki iw_wp" title="http://en.wikipedia.org/wiki/Tail_recursion">Tail Recursion</a> …
</p>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=c&amp;codeblock=2" title="Download Snippet" class="mediafile mf_c">mdc.c</a></dt>
<dd><pre class="code file c"><span class="kw4">int</span> mdc<span class="br0">&#40;</span><span class="kw4">int</span> x<span class="sy0">,</span> <span class="kw4">int</span> y<span class="br0">&#41;</span>
<span class="br0">&#123;</span>
	<span class="kw1">if</span><span class="br0">&#40;</span><span class="sy0">!</span>y<span class="br0">&#41;</span> <span class="kw1">return</span> x<span class="sy0">;</span>
	<span class="kw1">return</span> mdc<span class="br0">&#40;</span>y<span class="sy0">,</span> x <span class="sy0">%</span> y<span class="br0">&#41;</span><span class="sy0">;</span>
<span class="br0">&#125;</span></pre>
</dd></dl>

<p>
… we can delete de <a href="http://en.wikipedia.org/wiki/Tail_recursion" class="interwiki iw_wp" title="http://en.wikipedia.org/wiki/Tail_recursion">Tail_recursion</a> return(s) …
</p>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=c&amp;codeblock=3" title="Download Snippet" class="mediafile mf_c">mdc_changed.c</a></dt>
<dd><pre class="code file c"><span class="kw4">int</span> mdc<span class="br0">&#40;</span><span class="kw4">int</span> x<span class="sy0">,</span> <span class="kw4">int</span> y<span class="br0">&#41;</span>
<span class="br0">&#123;</span>
	<span class="kw1">if</span><span class="br0">&#40;</span><span class="sy0">!</span>y<span class="br0">&#41;</span> <span class="kw1">return</span> x<span class="sy0">;</span>
	mdc<span class="br0">&#40;</span>y<span class="sy0">,</span> x <span class="sy0">%</span> y<span class="br0">&#41;</span><span class="sy0">;</span>
<span class="br0">&#125;</span></pre>
</dd></dl>

<p>
… This works because the return value goes to eax register and, as the other function calls don&#039;t change its value, they return the same as the last call done.
</p>

<p>
Another example:
</p>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=c&amp;codeblock=4" title="Download Snippet" class="mediafile mf_c">ackermann.c</a></dt>
<dd><pre class="code file c"><span class="kw4">int</span> ackermann<span class="br0">&#40;</span><span class="kw4">int</span> m<span class="sy0">,</span> <span class="kw4">int</span> n<span class="br0">&#41;</span>
<span class="br0">&#123;</span>
	<span class="kw1">if</span><span class="br0">&#40;</span><span class="sy0">!</span>m<span class="br0">&#41;</span> <span class="kw1">return</span> n <span class="sy0">+</span> <span class="nu0">1</span><span class="sy0">;</span>
	<span class="kw1">if</span><span class="br0">&#40;</span><span class="sy0">!</span>n<span class="br0">&#41;</span> <span class="kw1">return</span> ackermann<span class="br0">&#40;</span>m <span class="sy0">-</span> 1<span class="sy0">,</span> 1<span class="br0">&#41;</span><span class="sy0">;</span>
	<span class="kw1">return</span> ackermann<span class="br0">&#40;</span>m <span class="sy0">-</span> 1<span class="sy0">,</span> ackermann<span class="br0">&#40;</span>m<span class="sy0">,</span> n <span class="sy0">-</span> 1<span class="br0">&#41;</span><span class="br0">&#41;</span><span class="sy0">;</span>
<span class="br0">&#125;</span></pre>
</dd></dl>

<p>
This time we have two tail recursive calls, so we need an else.
</p>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=c&amp;codeblock=5" title="Download Snippet" class="mediafile mf_c">ackermann_changed.c</a></dt>
<dd><pre class="code file c"><span class="kw4">int</span> ackermann<span class="br0">&#40;</span><span class="kw4">int</span> m<span class="sy0">,</span> <span class="kw4">int</span> n<span class="br0">&#41;</span>
<span class="br0">&#123;</span>
	<span class="kw1">if</span><span class="br0">&#40;</span><span class="sy0">!</span>m<span class="br0">&#41;</span> <span class="kw1">return</span> n <span class="sy0">+</span> <span class="nu0">1</span><span class="sy0">;</span>
	<span class="kw1">if</span><span class="br0">&#40;</span><span class="sy0">!</span>n<span class="br0">&#41;</span> ackermann<span class="br0">&#40;</span>m <span class="sy0">-</span> 1<span class="sy0">,</span> 1<span class="br0">&#41;</span><span class="sy0">;</span>
	<span class="kw1">else</span> ackermann<span class="br0">&#40;</span>m <span class="sy0">-</span> 1<span class="sy0">,</span> ackermann<span class="br0">&#40;</span>m<span class="sy0">,</span> n <span class="sy0">-</span> 1<span class="br0">&#41;</span><span class="br0">&#41;</span><span class="sy0">;</span>
<span class="br0">&#125;</span></pre>
</dd></dl>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Tail Recursion Without Return" [643-1568] -->
<h2><a name="minimal_factorial_program" id="minimal_factorial_program">Minimal Factorial Program</a></h2>
<div class="level2">
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=c&amp;codeblock=6" title="Download Snippet" class="mediafile mf_c">f.c</a></dt>
<dd><pre class="code file c">main<span class="br0">&#40;</span>n<span class="br0">&#41;</span><span class="br0">&#123;</span><span class="kw1">return</span> <span class="sy0">!</span>n<span class="sy0">?:</span>n<span class="sy0">*</span>main<span class="br0">&#40;</span>n<span class="sy0">-</span>1<span class="br0">&#41;</span><span class="sy0">;</span><span class="br0">&#125;</span></pre>
</dd></dl>
<pre class="code bash">$ <span class="kw2">gcc</span> <span class="re5">-o</span> f f.c
$ .<span class="sy0">/</span>f<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
1
$ .<span class="sy0">/</span>f .<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
2
$ .<span class="sy0">/</span>f . .<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
6
$ .<span class="sy0">/</span>f . . .<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
24
$ .<span class="sy0">/</span>f . . . .<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
<span class="nu0">120</span></pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Minimal Factorial Program" [1569-1806] -->
<h3><a name="explanation" id="explanation">Explanation</a></h3>
<div class="level3">
<ul>
<li class="level1"><div class="li"> main return type defaults to int</div>
</li>
<li class="level1"><div class="li"> main first parameter defaults to int and is the number of command line arguments</div>
</li>
<li class="level1"><div class="li"> ”!n” is the same as “n == 0”</div>
</li>
<li class="level1"><div class="li"> “x ? : y” is the same as “x ? x : y”</div>
</li>
<li class="level1"><div class="li"> $? is the return value of the program</div>
</li>
</ul>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Explanation" [1807-2068] -->
<h2><a name="minimal_fibonacci_program" id="minimal_fibonacci_program">Minimal Fibonacci Program</a></h2>
<div class="level2">

<p>

Same idea of the factorial.
</p>
<dl class="file">
<dt><a href="/~kssilveira/site/doku.php?do=export_code&amp;id=c&amp;codeblock=8" title="Download Snippet" class="mediafile mf_c">f.c</a></dt>
<dd><pre class="code file c">main<span class="br0">&#40;</span>n<span class="br0">&#41;</span><span class="br0">&#123;</span><span class="kw1">return</span> n<span class="sy0">&lt;</span>2<span class="sy0">?:</span>main<span class="br0">&#40;</span>n<span class="sy0">-</span>1<span class="br0">&#41;</span><span class="sy0">+</span>main<span class="br0">&#40;</span>n<span class="sy0">-</span>2<span class="br0">&#41;</span><span class="sy0">;</span><span class="br0">&#125;</span></pre>
</dd></dl>
<pre class="code bash">$ <span class="kw2">gcc</span> <span class="re5">-o</span> f f.c
$ .<span class="sy0">/</span>f<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
1
$ .<span class="sy0">/</span>f .<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
2
$ .<span class="sy0">/</span>f . .<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
3
$ .<span class="sy0">/</span>f . . .<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
5
$ .<span class="sy0">/</span>f . . . .<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
8
$ .<span class="sy0">/</span>f . . . . .<span class="sy0">||</span><span class="kw3">echo</span> <span class="re4">$?</span>
<span class="nu0">13</span></pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Minimal Fibonacci Program" [2069-2369] -->
<h2><a name="how_to_pass_a_matrix_as_parameter_to_a_funcion" id="how_to_pass_a_matrix_as_parameter_to_a_funcion">How to pass a matrix as parameter to a funcion</a></h2>
<div class="level2">
<pre class="code c"><span class="kw4">int</span> sum2<span class="br0">&#40;</span><span class="kw4">int</span> n<span class="sy0">,</span> <span class="kw4">int</span> m<span class="sy0">,</span> <span class="kw4">int</span> matrix<span class="br0">&#91;</span>n<span class="br0">&#93;</span><span class="br0">&#91;</span>m<span class="br0">&#93;</span><span class="br0">&#41;</span>
<span class="br0">&#123;</span>
  <span class="kw4">int</span> i<span class="sy0">,</span> j<span class="sy0">,</span> sum<span class="sy0">;</span>
  <span class="kw1">for</span><span class="br0">&#40;</span>i <span class="sy0">=</span> sum <span class="sy0">=</span> <span class="nu0">0</span><span class="sy0">;</span> i <span class="sy0">&lt;</span> n<span class="sy0">;</span> i<span class="sy0">++</span><span class="br0">&#41;</span>
    <span class="kw1">for</span><span class="br0">&#40;</span>j <span class="sy0">=</span> <span class="nu0">0</span><span class="sy0">;</span> j <span class="sy0">&lt;</span> m<span class="sy0">;</span> j<span class="sy0">++</span><span class="br0">&#41;</span>
      sum <span class="sy0">+=</span> matrix<span class="br0">&#91;</span>i<span class="br0">&#93;</span><span class="br0">&#91;</span>j<span class="br0">&#93;</span><span class="sy0">;</span>
  <span class="kw1">return</span> sum<span class="sy0">;</span>
<span class="br0">&#125;</span>
&nbsp;
<span class="kw4">int</span> sum3<span class="br0">&#40;</span><span class="kw4">int</span> n<span class="sy0">,</span> <span class="kw4">int</span> m<span class="sy0">,</span> <span class="kw4">int</span> p<span class="sy0">,</span> <span class="kw4">int</span> matrix<span class="br0">&#91;</span>n<span class="br0">&#93;</span><span class="br0">&#91;</span>m<span class="br0">&#93;</span><span class="br0">&#91;</span>p<span class="br0">&#93;</span><span class="br0">&#41;</span>
<span class="br0">&#123;</span>
  <span class="co1">// ...</span>
<span class="br0">&#125;</span></pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "How to pass a matrix as parameter to a funcion" [2370-2673] -->
<h2><a name="designated_initializers" id="designated_initializers">Designated Initializers</a></h2>
<div class="level2">
<pre class="code c"><span class="coMULTI">/* [index] = value */</span>
<span class="kw4">int</span> a<span class="br0">&#91;</span>6<span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#123;</span> <span class="br0">&#91;</span>4<span class="br0">&#93;</span> <span class="sy0">=</span> 29<span class="sy0">,</span> <span class="br0">&#91;</span>2<span class="br0">&#93;</span> <span class="sy0">=</span> 15 <span class="br0">&#125;</span><span class="sy0">;</span>     <span class="co1">// { 0, 0, 15, 0, 29, 0 };</span>
&nbsp;
<span class="kw4">int</span> a<span class="br0">&#91;</span>6<span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#123;</span> <span class="br0">&#91;</span>1<span class="br0">&#93;</span> <span class="sy0">=</span> v1<span class="sy0">,</span> v2<span class="sy0">,</span> <span class="br0">&#91;</span>4<span class="br0">&#93;</span> <span class="sy0">=</span> v4 <span class="br0">&#125;</span><span class="sy0">;</span> <span class="co1">// { 0, v1, v2, 0, v4, 0 };</span>
&nbsp;
<span class="kw4">int</span> a<span class="br0">&#91;</span>6<span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#123;</span> <span class="br0">&#91;</span>1 ... 4<span class="br0">&#93;</span> <span class="sy0">=</span> 1 <span class="br0">&#125;</span><span class="sy0">;</span>          <span class="co1">// { 0, 1, 1, 1, 1, 0 }</span>
&nbsp;
<span class="coMULTI">/* also works with chars */</span>
<span class="kw4">int</span> isWhitespace<span class="br0">&#91;</span><span class="nu0">256</span><span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#123;</span> <span class="br0">&#91;</span><span class="st0">' '</span><span class="br0">&#93;</span> <span class="sy0">=</span> <span class="nu0">1</span><span class="sy0">,</span> <span class="br0">&#91;</span><span class="st0">'<span class="es1">\t</span>'</span><span class="br0">&#93;</span> <span class="sy0">=</span> <span class="nu0">1</span><span class="sy0">,</span> <span class="br0">&#91;</span><span class="st0">'<span class="es1">\n</span>'</span><span class="br0">&#93;</span> <span class="sy0">=</span> 1 <span class="br0">&#125;</span><span class="sy0">;</span></pre>
<pre class="code c"><span class="kw4">struct</span> point <span class="br0">&#123;</span> <span class="kw4">int</span> x<span class="sy0">,</span> y<span class="sy0">;</span> <span class="br0">&#125;</span><span class="sy0">;</span>
&nbsp;
<span class="coMULTI">/* .fieldname = value */</span>
<span class="kw4">struct</span> point p <span class="sy0">=</span> <span class="br0">&#123;</span> .<span class="me1">y</span> <span class="sy0">=</span> yvalue<span class="sy0">,</span> .<span class="me1">x</span> <span class="sy0">=</span> xvalue <span class="br0">&#125;</span><span class="sy0">;</span> <span class="co1">// p = { xvalue, yvalue };</span>
&nbsp;
<span class="coMULTI">/* [index].fieldname = value */</span>
<span class="kw4">struct</span> point ptarray<span class="br0">&#91;</span>10<span class="br0">&#93;</span> <span class="sy0">=</span> <span class="br0">&#123;</span> <span class="br0">&#91;</span>2<span class="br0">&#93;</span>.<span class="me1">y</span> <span class="sy0">=</span> yv2<span class="sy0">,</span> <span class="br0">&#91;</span>2<span class="br0">&#93;</span>.<span class="me1">x</span> <span class="sy0">=</span> xv2<span class="sy0">,</span> <span class="br0">&#91;</span>0<span class="br0">&#93;</span>.<span class="me1">x</span> <span class="sy0">=</span> xv0 <span class="br0">&#125;</span><span class="sy0">;</span></pre>
<div class="plugin_uparrow">
  <a href="#" title="Back to top">
    <img src="lib/plugins/uparrow/images/tango-small.png" alt="Back to top"/>
  </a>
</div>

</div>
<!-- SECTION "Designated Initializers" [2674-] -->